//XSETASETA@GMAIL.COM
//SETA43

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>


#include "main.h"


int  ContadorI=0;
char Binput[100];
char Binput2[10];
int tiempo2=2,tiempo1=2;

int canal,frecuencia;
float frecu;

unsigned char portok;

//_________________________

void EV_Init();
void MiTimer();
void analizarIN();
void PrintTextI(int num,int n);
void PrintTextF(int num,float f);

int SearchPort();



void PrintTextAll(void)
{	
	PrintTextF(0,frecu);
	PrintTextI(1,canal);
	if(portok==1)
		TextEntrada(2,MODEMDEVICE);
	 else
		TextEntrada(2,"No_radio");
	SDL_Flip( screen );
} 


int load_files()
{
	background = load_image( "modelo2.png" );
	if( background == NULL )  return 0;
	dots = load_image( "modelo1.png" );
	if( dots == NULL )  return 0;

	font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
	{
		printf("Error cargando Font\n");
		return 0;
	}	
	return 1;
}

void RepintarPantalla()
{
	SDL_WM_SetCaption( "RadioARDU_sdl", NULL );
	apply_surface( 0, 0, background, screen );
	
	PaintBotones();
	PaintLuces();
	PaintEntradas();
	PaintTextos();
	PrintTextAll();
	SDL_Flip( screen );
}


int main (int argc, char *argv[])
{
	int quit = 0;
	int mouse_x,mouse_y;
	Uint8 *teclas; 
	int zboton=0;
	int z;
	
	
#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif
	printf("SDL_Radio_ARDU\n");

    Initextos();
	Inibotones();
	IniLuces ();
	Inientradas();
	
	if( init() == 0 ) return 1;	
	if( load_files() == 0 ) return 2;	
	RepintarPantalla();	
	if( SDL_Flip( screen ) == -1 ) return 3;
	
	RepintarPantalla();


		z=SearchPort();
		if(z==-1)
			 printf("No RADIO %d\n",z);
			else
		      MODEMDEVICE=myport[z]; 
	
#if YesWindows
	if(hSerial)CloseRs232();
#else		
	if(fdrs232)CloseRs232();
#endif		 

	if(0!=IniRs232())
	{
		if(DEBUG) printf("NO %s\n",MODEMDEVICE);
		portok=0;
	}
	else
	{		
		if(DEBUG) printf("SI %s\n",MODEMDEVICE);  		
		portok=1;
	}			
		
	

	ContadorI=0;
	while( quit == 0 )
	{	
		SDL_Delay(200);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] )
			{					
				printf("K_END Programa\n");	goto salir;
			}
			if( event.type == SDL_QUIT )   quit = 1;
			if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");
				if(event.key.keysym.sym == SDLK_f)
				{  
          #if YesWindows
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
					SDL_WM_ToggleFullScreen(screen);
          #endif  
					RepintarPantalla();
				}
				if(event.key.keysym.sym == SDLK_m)
				{
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				}
			}
			
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
				{               					
					switch (zboton)
					{                         
						case 0: 							
						if(DEBUG) printf("B_END Programa\n");
						goto salir;
						break;    
						case 1: 
						if(DEBUG)printf("B_>\n");
						if(canal < 210) canal++;
						sprintf(VARI,"ncanal=%d\n",canal);
						PrintSerial(VARI);
						break;                               
						case 2:
						if(DEBUG)printf("B_<\n");
						if(canal>0)		canal--;
						sprintf(VARI,"ncanal=%d\n",canal);
						PrintSerial(VARI); 
						break; 
						case 3:
						if(DEBUG)printf("B_<<\n");
						PrintSerial((char *)"buscar-\n");               
						break; 
						case 4:
						if(DEBUG)printf("B_>>\n");
						PrintSerial((char *)"buscar+\n");                           
						break; 
						case 5:
						if(DEBUG)printf("B_Init\n");
						EV_Init();									
						break;
						case 6:
						if(DEBUG)printf("B_vol+\n");
						PrintSerial((char *)"volume+\n");
						
						break; 
						case 7:
						if(DEBUG)printf("B_vol-\n");
						PrintSerial((char *)"volume-\n");					            
						break; 
					} 
					PaintBoton(zboton,1);
					PrintTextAll();
//					 SDL_Flip( screen );
				}
				if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
			}
			if( event.type == SDL_MOUSEBUTTONUP ) 
			{
				if(zboton!=-1)
				{
					SDL_Delay(100);
					PaintBotones();
					PaintLuces();
					SDL_Flip( screen );
				}
				
				if(DEBUG)printf("RepintarBoton %d\n",zboton);
				zboton=-1;					
			}
		}
	}
	
	salir: 
     //Cerrar todo el SDL
    PrintSerial((char *)"volume=0\n");
	clean_up();
	SDL_Delay(1000);
	CloseRs232();
	return 0;  
}

//____________________FIN____________

void MiTimer()
{
	int nbytes;
	tiempo1--;
	tiempo2--;	

// cada 0,5 segundos
	if(portok==1 && tiempo2<0)
	{
		tiempo2=2;	
		
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
					//printf("Leer %d -> %s\n",ContadorI,Binput2);	
				Binput[ContadorI]=Binput2[0];
				ContadorI++;
				if (Binput2[0] == '\n')
				{
					if(ContadorI<2)ContadorI=2;   
					Binput[ContadorI-2]=0;
					ContadorI=0;	
					if(DEBUG)printf("Leidos-> %s\n",Binput);
					sprintf(VARI,"%s",Binput);	
					analizarIN();																	
				}															
			}
		}	 
		
// cada 1 segundos ____________________________________________
		if(tiempo1<0)
		{
			tiempo1=20;
			if(DEBUG) printf("1S  portok=%d\n",portok);				
			PrintTextAll();
			SDL_Flip( screen );
			//printf("F=%f   C=%d \n",frecu,canal);
		}

	}


void PrintTextI(int num,int n)
	{
		sprintf(VARI,"%d",n);
		TextEntrada(num,VARI);
	}

void PrintTextF(int num,float f)
	{
		sprintf(VARI,"%.2f",f);
		TextEntrada(num,VARI);
	}

	
void analizarIN()
	{
  //int zz;
		if(!strncmp(VARI,"Canal=",6))
		{
			strncpy(Binput2,VARI+6,4);
			canal=atoi(Binput2);
			PrintTextAll();		 
			if(DEBUG)printf("OK_Canal =%d \n",canal);
			goto salirpro;
		}
		if(!strncmp(VARI,"Frecuencia=",11)) 
		{
			strncpy(Binput2,VARI+11,4);
			frecuencia=atoi(Binput2);	
			frecu=frecuencia;	frecu/=10;			 
			PrintTextAll();
			if(DEBUG)printf("OK_Frecuencia =%d \n",frecuencia);
			goto salirpro;
		}
		if(DEBUG)printf("->%s\n",VARI);
		salirpro:
		;
	}

// No se utiliza 
	void EV_Init()
	{
	#if YesWindows
		if(hSerial)CloseRs232();
	#else		
		if(fdrs232)CloseRs232();
	#endif		 
		MODEMDEVICE=myport[0];

		if(0!=IniRs232())
		{
			if(DEBUG) printf("NO %s\n",MODEMDEVICE);
			portok=0;
		}
		else
		{		
			if(DEBUG) printf("SI %s\n",MODEMDEVICE);    		      
			portok=1;
		}					
	}
//______________

	int SearchPort()
	{
		int z,zz,nbytes;
		
		printf("Search serial\n");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
				if(DEBUG)printf("Port %s\n",MODEMDEVICE);
				if(0==IniRs232())
				{               
					DelayMs(1000);
					PrintSerial((char *)"\n\n"); 
					DelayMs(100);
					PrintSerial((char *)"RADIO1=\n");
					DelayMs(100);
					
					ContadorI=0; 
					for(zz=0;zz<10;zz++)
					{
						DelayMs(200);
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
							while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
							 //if(DEBUG)printf("Leer %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								ContadorI++;
								if (Binput2[0] == '\n')
								{
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(VARI,"%s",Binput);
                                 //printf("==%s\n",VARI);
									if(!strncmp(VARI,"OK",2))
									{
										printf("Radio found at %s\n",MODEMDEVICE);
										CloseRs232();                                   
										return z;
									}			
								}
							}	  	  
						}             
					}
					CloseRs232();
				}
				printf("Radio no found \n");
				return -1;
			}
